<?php

namespace Aerex\TaskwarriorPlugin;

use Aerex\TaskwarriorPlugin\TW\Taskwarrior;
use Aerex\TaskwarriorPlugin\TW\TaskwarriorManager; 

class Config {

   /**
     * @var string
     */
    private $bin;

    /**
     * @var string
     */
    private $taskrc;

    /**
     * @var string
     */
    private $taskData;

    /**
     * @var array
     */
    private $rcOptions;

    


    public function __construct($taskrc='~/.taskrc', $taskData='~/.task',$rcOptions = [], $bin='task'){
      $this->taskrc = $taskrc;
      $this->bin = $bin;
      $this->taskData = $taskData;
      $this->rcOptions = array_merge(
            array(
                'rc:' . $this->taskrc,
                'rc.data.location=' . $this->taskData,
                'rc.json.array=true',
                'rc.json.depends.array=true',
                'rc.confirmation=no',
            ),
            $rcOptions
        );

    }

    public function getTaskBin(){
      return $this->bin;
    }

    public function getOptions(){
      return $this->rcOptions;
    }


    public function getTaskwarriorInstance(){

      $this->taskwarrior = new Taskwarrior($this->taskrc,$this->taskdatadir, [], $this->taskbinfile);
      $this->taskwarriorManager = new TaskwarriorManager($this->taskwarrior);

      return $this->taskwarriorManager;
    }


    public function getLogger(){
      return $this->logger;
    }
    public function setLogger($logger){
      $this->logger = $logger;

    }

}
?>
